﻿Imports System.ComponentModel

<DefaultEvent("CheckedChanged")> _
Public Class CheckMenu : Inherits ToolStripMenuItem

    ' Shared Images: alle CheckMenu-Objekte greifen auf **dieselben** Images 
    '  zu, anstatt sich je eigene zu erzeugen
    Private Shared _Images As Image()

    Shared Sub New()
        ' Untiger ComponentResourceManager arbeitet auf der lokalen Ressource 
        '  "Checkmenu.resx". Um eine lokale Ressource-Datei zu erzeugen muss 
        '  zunächst von Component geerbt werden (hier: mittelbar über 
        '  ToolStripMenuItem). Dann in die Designer-Ansicht von CheckMenu 
        '  gehen, ein beliebiges Item aus der Toolbox hinzufügen, und wieder 
        '  löschen. Im Projekt-Explorer "Alle Dateien anzeigen" aktivieren, 
        '  CheckMenu-Knoten erweitern, und Checkmenu.resx mit Doppelklick 
        '  öffnen. Jetzt können Bilder zugefügt werden. Sinn der lokalen 
        '  Bildressource ist, daß CheckMenu seine Bilder "mitnimmt", wenn es 
        '  in andere Projekte kopiert wird.
        With New ComponentResourceManager(GetType(CheckMenu))
            _Images = New Image() {CType(.GetObject("UnChecked"), Image), _
                CType(.GetObject("Checked"), Image)}
        End With
    End Sub

    Public Sub New()
        MyBase.New()
        Me.Image = _Images(0)
        MyBase.CheckOnClick = True
    End Sub

    Protected Overrides Sub OnCheckedChanged(ByVal e As System.EventArgs)
        MyBase.OnCheckedChanged(e)
        Me.Image = _Images(-CInt(MyBase.Checked))
    End Sub

End Class
